
#include "common.h"

// 'g' <-> global, 'd' <-> device
// global variable storing the current 3x3 filter into device constant memory
// you must use cudaMemcpyToSymbol() to copy the values into that variable
__constant__ float gd_filter[3][3];


// kernel applying a 3x3 filter to an image
__global__ void apply_3x3filter_kernel( /* TODO */)
{
  // Here, you can use gd_filter[i][j] to access to the coefficient of the filter
  /* TODO */
}


__host__ void apply_3x3filter_cuda(FloatImageGray& img, float filter[3][3], int n)
{
  // copy of the 3x3 filter values into constant device memory
  CUDA_SAFE_CALL( cudaMemcpyToSymbol(gd_filter, filter, sizeof(float)*9) );
  
  /* TODO */
}

